/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.tables.records.VDataquierValuelistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierValuelist extends TableImpl<VDataquierValuelistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier_valuelist</code>
     */
    public static final VDataquierValuelist V_DATAQUIER_VALUELIST = new VDataquierValuelist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierValuelistRecord> getRecordType() {
        return VDataquierValuelistRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_valuelist.fk_valuelist</code>.
     */
    public final TableField<VDataquierValuelistRecord, Integer> FK_VALUELIST = createField(DSL.name("fk_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_valuelist.codes</code>.
     */
    public final TableField<VDataquierValuelistRecord, String> CODES = createField(DSL.name("codes"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_valuelist.isocode</code>.
     */
    public final TableField<VDataquierValuelistRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    private VDataquierValuelist(Name alias, Table<VDataquierValuelistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierValuelist(Name alias, Table<VDataquierValuelistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_valuelist" as  SELECT val.fk_value_valuelist AS fk_valuelist,
          string_agg(((val.varvalue || '='::text) || valt.value), '|'::text ORDER BY val.value_order) AS codes,
          valt.isocode
         FROM ((common_dd.t_core_value val
           LEFT JOIN common_dd.t_core_valueparam valp ON ((valp.fk_valueparam_value = val.pk_core_value)))
           LEFT JOIN common_dd.t_core_translation valt ON (((valt.fk_trans_key = valp.param_key) AND (valt.category = 'crf'::common_dd.enum_trans_category))))
        GROUP BY val.fk_value_valuelist, valt.isocode;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_valuelist</code> table
     * reference
     */
    public VDataquierValuelist(String alias) {
        this(DSL.name(alias), V_DATAQUIER_VALUELIST);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_valuelist</code> table
     * reference
     */
    public VDataquierValuelist(Name alias) {
        this(alias, V_DATAQUIER_VALUELIST);
    }

    /**
     * Create a <code>common_dd.v_dataquier_valuelist</code> table reference
     */
    public VDataquierValuelist() {
        this(DSL.name("v_dataquier_valuelist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierValuelist as(String alias) {
        return new VDataquierValuelist(DSL.name(alias), this);
    }

    @Override
    public VDataquierValuelist as(Name alias) {
        return new VDataquierValuelist(alias, this);
    }

    @Override
    public VDataquierValuelist as(Table<?> alias) {
        return new VDataquierValuelist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierValuelist rename(String name) {
        return new VDataquierValuelist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierValuelist rename(Name name) {
        return new VDataquierValuelist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierValuelist rename(Table<?> name) {
        return new VDataquierValuelist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist where(Condition condition) {
        return new VDataquierValuelist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierValuelist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierValuelist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierValuelist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierValuelist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierValuelist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
